Index: trunk/src/ProcessManagement/ProcessManagement/Forms/DataEntry/AverageScore/FrmAverageScoreAux.cs
===================================================================
--- trunk/src/ProcessManagement/ProcessManagement/Forms/DataEntry/AverageScore/FrmAverageScoreAux.cs	(nonexistent)
+++ trunk/src/ProcessManagement/ProcessManagement/Forms/DataEntry/AverageScore/FrmAverageScoreAux.cs	(revision 484)
@@ -0,0 +1,1007 @@
+﻿using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Text;
+using System.Windows.Forms;
+using System.Threading.Tasks;
+using System.Diagnostics;
+using System.Linq;
+
+using log4net;
+using log4net.Appender;
+using log4net.Repository.Hierarchy;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB.Core;
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.Forms.ControlsAction;
+using ProcessManagement.Forms.SubForms;
+
+namespace ProcessManagement.Forms.DataEntry
+{
+    partial class FrmAverageScore
+    {
+        #region フォームロード時の処理
+        /// <summary>
+        /// フォームロード時の処理
+        /// </summary>
+        private void InitFormLoad()
+        {
+            try
+            {
+                // コントロール選択制御
+                EnableControl(false);
+
+                // データ表示
+                DataDisplay();
+
+                // コンボボックスイベント制御
+                CmbEventControl(true);
+                // コントロール選択制御
+                EnableControl(true);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region コンボボックスイベント制御
+        /// <summary>
+        /// コンボボックスイベント制御
+        /// </summary>
+        private void CmbEventControl(bool bOn)
+        {
+            try
+            {
+                if (bOn)
+                {
+                    cmbDivision.TextChanged += new EventHandler(cmbDivision_TextChanged);
+                    cmbCode.TextChanged += new EventHandler(cmbCode_TextChanged);
+                }
+                else
+                {
+                    cmbDivision.TextChanged -= new EventHandler(cmbDivision_TextChanged);
+                    cmbCode.TextChanged -= new EventHandler(cmbCode_TextChanged);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region コントロール選択制御
+        /// <summary>
+        /// コントロール選択制御
+        /// </summary>
+        /// <param name="bOn"></param>
+        private void EnableControl(bool bOn)
+        {
+            try
+            {
+                cmbDivision.Enabled = bOn;
+                cmbCode.Enabled = bOn;
+                btnOtherProc.Enabled = bOn;
+                btnEnd.Enabled = bOn;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region グリッドの表示カラムを制御する
+        /// <summary>
+        /// グリッドの表示カラムを制御する
+        /// </summary>
+        private void GridColumnsControl()
+        {
+            try
+            {
+                DataGridView dgv = dgvAverage;
+
+                bool[] bSet = new bool[] { false, true };
+                if (radioButton2.Checked)
+                {
+                    bSet[0] = true;
+                    bSet[1] = false;
+                }
+
+                dgv.Columns[(int)DispGrid.ManName1].Visible = bSet[0];
+                dgv.Columns[(int)DispGrid.ManAvgScore1].Visible = bSet[0];
+                dgv.Columns[(int)DispGrid.ManName2].Visible = bSet[1];
+                dgv.Columns[(int)DispGrid.ManAvgScore2].Visible = bSet[1];
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 当期より5年前の4月1日を返す
+        /// <summary>
+        /// 当期より5年前の4月1日を返す
+        /// </summary>
+        /// <returns></returns>
+        private DateTime Before5Year()
+        {
+            try
+            {
+                DateTime dtSt = DateTime.Today;
+                // 公共事業年度は固定で4/1よりの今期より5年前までを対象
+                if (DateTime.Today.Month < 4)
+                    dtSt = new DateTime(DateTime.Today.Year, 3, 31);
+                else
+                    dtSt = new DateTime((DateTime.Today.Year + 1), 3, 31);
+                dtSt = dtSt.AddYears(-5);
+
+                return dtSt;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return DateTime.Today;
+            }
+        }
+        #endregion
+
+        #region 評価点０を除外する
+        /// <summary>
+        /// 評価点０を除外する
+        /// </summary>
+        /// <returns></returns>
+        private string ZeroExclude()
+        {
+            try
+            {
+                return " And Calc.EvaluationScore > 0";
+                //return string.Empty;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return string.Empty;
+            }
+        }
+        #endregion
+
+        #region 選択条件により５年間選択のＳＱＬを返す
+        /// <summary>
+        /// 選択条件により５年間選択のＳＱＬを返す
+        /// </summary>
+        /// <returns></returns>
+        private string SetBeforeYear()
+        {
+            try
+            {
+                string strRet = string.Empty;
+                if (radioButton3.Checked)
+                {
+                    // 当期より5年前の4月1日を返す
+                    DateTime dtSt = Before5Year();
+                    strRet = string.Format(" And '{0}' <= DATE(Calc.OrderDate)", dtSt.ToShortDateString());
+                }
+                return strRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return string.Empty;
+            }
+        }
+        #endregion
+
+        #region 発注区分コンボボックスをセットする
+        /// <summary>
+        /// 発注区分コンボボックスへ文字をセットする
+        /// </summary>
+        private void SetcmbDivision()
+        {
+            IOMDivision DiviDB = new IOMDivision();
+            try
+            {
+                // 区分マスタを検索する
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.Append(" SELECT");
+                strSQL.Append(" Distinct Division.NameCode");
+                strSQL.Append(" , Division.NameString");
+                strSQL.Append(" FROM DivisionMaster As Division");
+                strSQL.Append(" Inner Join orderersmaster As Orders");
+                strSQL.AppendFormat("  On Orders.OrderCotegory = Division.NameCode");
+                strSQL.Append(" Inner Join constructionbaseinfo As Calc");
+                strSQL.Append("        On Calc.OrderersDivision = Orders.OrderCotegory");
+                strSQL.Append("        And Calc.OrderersCode = Orders.OrderersCode");
+                // 条件により当期より5年前をセット
+                strSQL.Append(SetBeforeYear());
+                // 評価点０を除外する
+                strSQL.Append(ZeroExclude());
+
+                strSQL.Append(" Inner Join constructiontypemaster As Type");
+                strSQL.Append("        On Type.TypeCode = Calc.ConstructionType");
+                strSQL.AppendFormat("  And Type.PublicFlg = {0}", (int)ConstructionTypeMaster.PublicFlgDef.Community);
+                strSQL.Append(" Where");
+                strSQL.AppendFormat(" Division.DivisionCode = {0}", (int)DivisionMaster.DivisionMasterCodeDef.OrderDivision);
+                strSQL.Append(" Order By Division.NameCode");
+
+                ArrayList arList = new ArrayList();
+                if (!DiviDB.ExecuteReader(strSQL.ToString(), ref arList)) return;
+
+                List<KeyValuePair<int, string>> DataList = new List<KeyValuePair<int, string>>();
+                DataList.Add(new KeyValuePair<int, string>(0, ""));
+
+                foreach (object[] work in arList)
+                {
+                    int NameCode = CommonMotions.cnvInt(work[0]);
+                    string NameString = CommonMotions.cnvString(work[1]);
+                    KeyValuePair<int, string> keyval = new KeyValuePair<int, string>(NameCode, NameString);
+
+                    DataList.Add(keyval);
+                }
+
+                this.cmbDivision.DataSource = null;
+                this.cmbDivision.Items.Clear();
+                this.cmbDivision.Text = "";
+
+                // コンボボックス初期表示
+                ComboBoxAction.InitDataSetCombBox(cmbDivision, DataList);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                DiviDB.close(); DiviDB = null;
+            }
+        }
+        #endregion
+
+        #region 発注者コンボボックスをセットする
+        /// <summary>
+        /// 発注者コンボボックスへ文字をセットする
+        /// </summary>
+        private void SetcmbCode()
+        {
+            IOMOrderers OrderDB = new IOMOrderers();
+            try
+            {
+                int nDivixionCode = CommonMotions.cnvInt(cmbDivision.SelectedValue);
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.Append("SELECT Distinct Orders.OrderersCode");
+                strSQL.Append(", Concat(Orders.OrderersName1, ' ', Orders.OrderersName2)");
+                strSQL.Append(" FROM orderersmaster As Orders");
+                strSQL.Append(" Inner Join constructionbaseinfo As Calc");
+                strSQL.Append("        On Calc.OrderersDivision = Orders.OrderCotegory");
+                strSQL.Append("        And Calc.OrderersCode = Orders.OrderersCode");
+                // 条件により当期より5年前をセット
+                strSQL.Append(SetBeforeYear());
+                // 評価点０を除外する
+                strSQL.Append(ZeroExclude());
+
+                strSQL.Append(" Inner Join constructiontypemaster As Type");
+                strSQL.Append("        On Type.TypeCode = Calc.ConstructionType");
+                strSQL.AppendFormat("  And Type.PublicFlg = {0}", (int)ConstructionTypeMaster.PublicFlgDef.Community);
+                strSQL.Append(" Where");
+                strSQL.AppendFormat(" Orders.OrderCotegory = {0}", nDivixionCode);
+                strSQL.Append(" Order By Orders.OrderersCode");
+  
+                // 発注者マスタ読込
+                ArrayList workList = new ArrayList();
+                if (!OrderDB.ExecuteReader(strSQL.ToString(), ref workList)) return;
+
+                List<KeyValuePair<int, string>> DataList = new List<KeyValuePair<int, string>>();
+                DataList.Add(new KeyValuePair<int, string>(0, ""));
+
+                foreach (object[] work in workList)
+                {
+                    int OrderersCode = CommonMotions.cnvInt(work[0]);
+                    string NameString = CommonMotions.cnvString(work[1]);
+                    KeyValuePair<int, string> keyval = new KeyValuePair<int, string>(OrderersCode, NameString);
+
+                    DataList.Add(keyval);
+                }
+
+                cmbCode.DataSource = null;
+                cmbCode.Items.Clear();
+                cmbCode.Text = "";
+
+                // コンボボックス初期表示
+                ComboBoxAction.InitDataSetCombBox(cmbCode, DataList);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                OrderDB.close(); OrderDB = null;
+            }
+        }
+        #endregion
+
+        #region データ表示
+        /// <summary>
+        /// 集計エリア位置
+        /// </summary>
+        private enum SumArea
+        {
+            Person = 0,
+            Division,
+            Order,
+        }
+        /// <summary>
+        /// データ表示
+        /// </summary>
+        private void DataDisplay()
+        {
+            DataGridView dgv = dgvAverage;
+            try
+            {
+                dgv.Rows.Clear();
+
+                // 表示データ
+                ArrayList ScoreData = new ArrayList();
+
+                // データ読込み
+                if (!ReadTable(ref ScoreData)) return;
+
+                int nNo = 0;
+                int nArrayCnt = Enum.GetNames(typeof(SumArea)).Length;
+
+                int[] BreakKey = new int[nArrayCnt];
+                decimal[] SumScore = new decimal[nArrayCnt];
+                int[] ScoreCount = new int[nArrayCnt];
+
+                int[] GetCode = new int[nArrayCnt];
+                string[] GetName = new string[nArrayCnt];
+
+                foreach (object[] ObjRec in ScoreData)
+                {
+                    GetCode[(int)SumArea.Person] = CommonMotions.cnvInt(ObjRec[(int)GetDataOrder.ConstrManCode]);
+                    GetCode[(int)SumArea.Division] = CommonMotions.cnvInt(ObjRec[(int)GetDataOrder.DivisionCode]);
+                    GetCode[(int)SumArea.Order] = CommonMotions.cnvInt(ObjRec[(int)GetDataOrder.OrderersCode]);
+
+                    GetName[(int)SumArea.Person] = CommonMotions.cnvString(ObjRec[(int)GetDataOrder.ManName]);
+                    GetName[(int)SumArea.Division] = CommonMotions.cnvString(ObjRec[(int)GetDataOrder.DivisionName]);
+                    GetName[(int)SumArea.Order] = CommonMotions.cnvString(ObjRec[(int)GetDataOrder.OrderersName]);
+
+                    int nConstrCode = CommonMotions.cnvInt(ObjRec[(int)GetDataOrder.ConstrCode]);
+                    string strConstrName = CommonMotions.cnvString(ObjRec[(int)GetDataOrder.ConstrName]);
+                    decimal decScore = CommonMotions.cnvDecimal(ObjRec[(int)GetDataOrder.EvaluationScore]);
+
+                    int nIndex = dgv.Rows.Add(1);
+                    DataGridViewRow CurRow = dgv.Rows[nIndex];
+
+                    // 表示コントロールブレイク処理
+                    CtrlBrkProc(nIndex, GetName, GetCode, ref BreakKey);
+
+                    // データセット
+                    CurRow.Cells[(int)DispGrid.DivisionCode].Value = GetCode[(int)SumArea.Division];
+                    CurRow.Cells[(int)DispGrid.OrderCode].Value = GetCode[(int)SumArea.Order];
+                    CurRow.Cells[(int)DispGrid.ManCode].Value = GetCode[(int)SumArea.Person];
+                    CurRow.Cells[(int)DispGrid.ConstrCode].Value = nConstrCode;
+
+                    CurRow.Cells[(int)DispGrid.No].Value = ++nNo;
+                    CurRow.Cells[(int)DispGrid.ConstrName].Value = strConstrName;
+                    CurRow.Cells[(int)DispGrid.ConstScore].Value = decScore.ToString("0.0");
+                }
+
+                // 最終平均値セット
+                if (ScoreData.Count > 0)
+                {
+                    int DivisionKey = BreakKey[(int)SumArea.Division];
+                    int OrderKey = BreakKey[(int)SumArea.Order];
+                    int PersonKey = BreakKey[(int)SumArea.Person];
+                    DataGridViewRow PersonRow = dgv.Rows
+                                                .Cast<DataGridViewRow>()
+                                                .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.DivisionCode].Value) == DivisionKey
+                                                            && CommonMotions.cnvInt(x.Cells[(int)DispGrid.OrderCode].Value) == OrderKey
+                                                            && CommonMotions.cnvInt(x.Cells[(int)DispGrid.ManCode].Value) == PersonKey)
+                                                .First();
+                    // 担当者平均点表示
+                    CtrlBrkProcType1Person(PersonRow.Index, GetName, ref GetCode, ref BreakKey, true);
+
+                    DataGridViewRow OrderRow = dgv.Rows
+                                                .Cast<DataGridViewRow>()
+                                                .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.DivisionCode].Value) == DivisionKey
+                                                            && CommonMotions.cnvInt(x.Cells[(int)DispGrid.OrderCode].Value) == OrderKey)
+                                                .First();
+                    // 発注者平均区分表示
+                    CtrlBrkProcType1Order(OrderRow.Index, GetName, ref GetCode, ref BreakKey, true);
+
+                    DataGridViewRow DiviRow = dgv.Rows
+                                                .Cast<DataGridViewRow>()
+                                                .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.DivisionCode].Value) == DivisionKey)
+                                                .First();
+                    // 発注者平均区分表示
+                    CtrlBrkProcType1Division(DiviRow.Index, GetName, ref GetCode, ref BreakKey, true);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                if (dgv.RowCount < s_RowDefault)
+                {
+                    dgv.RowCount += (s_RowDefault - dgv.RowCount);
+                }
+            }
+        }
+        #endregion
+
+        #region データ読込み
+        /// <summary>
+        /// データ読込み
+        /// </summary>
+        /// <returns></returns>
+        private bool ReadTable(ref ArrayList ScoreData)
+        {
+            IOAllFreeSQL FreeDB = new IOAllFreeSQL();
+            try
+            {
+                ScoreData.Clear();
+
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.Append(CreateSQLString());
+
+                if (!FreeDB.ExecuteReader(strSQL.ToString(), ref ScoreData)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                FreeDB.close(); FreeDB = null;
+            }
+        }
+        #endregion
+
+        #region 読込データ並び
+        /// <summary>
+        /// 読込データ並び
+        /// </summary>
+        private enum GetDataOrder
+        {
+            ConstrManCode = 0,
+            ManName,
+            ManDispOrder,
+            DivisionCode,
+            DivisionName,
+            DivisionDispOrder,
+            OrderersCode,
+            OrderersName,
+            OrdersDispOrder,
+            ConstrCode,
+            ConstrName,
+            EvaluationScore,
+        }
+        #endregion
+
+        #region データ取得SQL作成
+        /// <summary>
+        /// データ取得SQL作成
+        /// </summary>
+        /// <returns></returns>
+        private string CreateSQLString()
+        {
+            try
+            {
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.Append("Select");
+                strSQL.Append(" Calc.ConstructionPersonCode");
+                strSQL.Append(", Man.PersonName");
+                strSQL.Append(", Man.DisplayOrder");
+                strSQL.Append(", Calc.OrderersDivision");
+                strSQL.Append(", Division.NameString");
+                strSQL.Append(", Division.DisplayOrder");
+                strSQL.Append(", Calc.OrderersCode");
+                strSQL.Append(", CONCAT(Orders.OrderersName1, ' ', Orders.OrderersName2)");
+                strSQL.Append(", Orders.DisplayOrder");
+                strSQL.Append(", Calc.ConstructionCode");
+                strSQL.Append(", ConstrName.DetailString");
+                strSQL.Append(", Calc.EvaluationScore");
+                strSQL.Append(" From constructionbaseinfo As Calc");
+                strSQL.Append("      Inner Join constructiontypemaster As Type");
+                strSQL.Append("            On Type.TypeCode = Calc.ConstructionType");
+                strSQL.AppendFormat("      And Type.PublicFlg = {0}", (int)ConstructionTypeMaster.PublicFlgDef.Community);
+                strSQL.Append("      Inner Join divisionmaster As Division");
+                strSQL.AppendFormat("      On Division.DivisionCode = {0}", (int)DivisionMaster.DivisionMasterCodeDef.OrderDivision);
+                strSQL.Append("            And Division.NameCode = Calc.OrderersDivision");
+                strSQL.Append("      Inner Join orderersmaster As Orders");
+                strSQL.Append("            On Orders.OrderCotegory = Division.NameCode");
+                strSQL.Append("            And Orders.OrderersCode = Calc.OrderersCode");
+                strSQL.Append("      Inner Join personinchargemaster As Man");
+                strSQL.Append("            On Man.PersonCode = Calc.ConstructionPersonCode");
+                strSQL.AppendFormat("      And Man.DeleteFlg = {0}", (int)CommonDefine.DataDeleteDef.Exists);
+                strSQL.Append("      Inner Join constructionbaseinfodetail As ConstrName");
+                strSQL.Append("            On ConstrName.ConstructionCode = Calc.ConstructionCode");
+                strSQL.AppendFormat("      And ConstrName.DetailNo = {0}", (int)ConstructionBaseInfoDetail.DataNoDef.ConstructionName);
+                strSQL.Append(" Where");
+                strSQL.AppendFormat(" Calc.TyingFlg != {0}", (int)ConstructionBaseInfo.TyingFlgDef.Tying);
+                // 条件により当期より5年前をセット
+                strSQL.Append(SetBeforeYear());
+                // 評価点０を除外する
+                strSQL.Append(ZeroExclude());
+
+                int iStatus = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("非 受 注")).Key;
+                strSQL.Append(" And");
+                strSQL.AppendFormat(" Calc.ConstructionStatusFlg != {0}", iStatus);
+
+                // 発注者区分がある場合
+                if (cmbDivision.Text.Length > 0)
+                {
+                    strSQL.AppendFormat(" And Division.NameCode = {0}", cmbDivision.SelectedValue);
+                }
+                // 発注者がある場合
+                if (cmbCode.Text.Length > 0)
+                {
+                    strSQL.AppendFormat(" And Orders.OrderersCode = {0}", cmbCode.SelectedValue);
+                }
+
+                // 発注区分・担当者によって並びを変える
+                if (radioButton1.Checked)
+                {
+                    strSQL.Append(" Order By");
+                    strSQL.Append("      Division.DisplayOrder");
+                    strSQL.Append("      , Orders.DisplayOrder");
+                    strSQL.Append("      , Man.DisplayOrder");
+                    strSQL.Append("      , Calc.OrderDate");
+                }
+                else
+                {
+                    strSQL.Append(" Order By");
+                    strSQL.Append("        Man.DisplayOrder");
+                    strSQL.Append("      , Division.DisplayOrder");
+                    strSQL.Append("      , Orders.DisplayOrder");
+                    strSQL.Append("      , Calc.OrderDate");
+                }
+
+                return strSQL.ToString();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return string.Empty;
+            }
+        }
+        #endregion
+
+        #region 表示コントロールブレイク処理
+        /// <summary>
+        /// 表示コントロールブレイク処理
+        /// </summary>
+        private void CtrlBrkProc(int nIndex, string[] GetName, int[] GetCode, ref int[] BreakKey)
+        {
+            try
+            {
+                if (radioButton1.Checked)
+                {
+                    CtrlBrkProcType1(nIndex, GetName, ref GetCode, ref BreakKey);
+                }
+                else
+                {
+                    CtrlBrkProcType2(nIndex, GetName, ref GetCode, ref BreakKey);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 発注者別コントロールブレイク
+        /// <summary>
+        /// 発注者別コントロールブレイク
+        /// </summary>
+        private void CtrlBrkProcType1(int nIndex, string[] GetName, ref int[] GetCode, ref int[] BreakKey)
+        {
+            try
+            {
+                bool[] bExecute = new bool[] { false, false, false };
+                // ブレイク条件の上から比較する
+                if(GetCode[(int)SumArea.Division] != BreakKey[(int)SumArea.Division])
+                {
+                    bExecute[0] = true;
+                    bExecute[1] = true;
+                    bExecute[2] = true;
+                }
+                else if (GetCode[(int)SumArea.Order] != BreakKey[(int)SumArea.Order])
+                {
+                    bExecute[0] = true;
+                    bExecute[1] = true;
+                }
+                else if (GetCode[(int)SumArea.Person] != BreakKey[(int)SumArea.Person])
+                {
+                    bExecute[0] = true;
+                }
+
+                // 担当者平均点表示
+                if (bExecute[0]) CtrlBrkProcType1Person(nIndex, GetName, ref GetCode, ref BreakKey);
+
+                // 発注者平均区分表示
+                if (bExecute[1]) CtrlBrkProcType1Order(nIndex, GetName, ref GetCode, ref BreakKey);
+
+                // 発注者平均区分表示
+                if (bExecute[2]) CtrlBrkProcType1Division(nIndex, GetName, ref GetCode, ref BreakKey);
+
+                // ----- 新キーセット
+                if (bExecute[0]) BreakKey[(int)SumArea.Person] = GetCode[(int)SumArea.Person];
+
+                if (bExecute[1]) BreakKey[(int)SumArea.Order] = GetCode[(int)SumArea.Order];
+
+                if (bExecute[2]) BreakKey[(int)SumArea.Division] = GetCode[(int)SumArea.Division];
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 発注区分別コントロールブレイク発注区分平均点表示
+        /// <summary>
+        /// 発注区分別コントロールブレイク発注者平均区分表示
+        /// </summary>
+        private void CtrlBrkProcType1Division(int nIndex, string[] GetName, ref int[] GetCode, ref int[] BreakKey, bool bLast = false)
+        {
+            DataGridView dgv = dgvAverage;
+            try
+            {
+                // 先頭は抜ける
+                if (!bLast && nIndex < 1) return;
+
+                // ----- 発注区分平均値
+                int DivisionKey = BreakKey[(int)SumArea.Division];
+                DataGridViewRow DiviRow = dgv.Rows
+                                            .Cast<DataGridViewRow>()
+                                            .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.DivisionCode].Value) == DivisionKey)
+                                            .First();
+                if (DiviRow == null) return;
+
+                // 発注区分平均値セット
+                double dAvgDivi = dgv.Rows
+                                .Cast<DataGridViewRow>()
+                                .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.DivisionCode].Value) == DivisionKey)
+                                .Average(y => CommonMotions.cnvDouble(y.Cells[(int)DispGrid.ConstScore].Value));
+
+                // 発注区分平均値セット
+                DiviRow.Cells[(int)DispGrid.DiviAvgScore].Value = dAvgDivi.ToString("0.0");
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                if (nIndex >= 0)
+                {
+
+                    // 名前のセット
+                    DataGridViewRow CurRow = dgv.Rows[nIndex];
+                    CurRow.Cells[(int)DispGrid.DiviName].Value = GetName[(int)SumArea.Division];
+                }
+            }
+        }
+        #endregion
+
+        #region 発注者別コントロールブレイク発注者平均点表示
+        /// <summary>
+        /// 発注者別コントロールブレイク発注者平均点表示
+        /// </summary>
+        private void CtrlBrkProcType1Order(int nIndex, string[] GetName, ref int[] GetCode, ref int[] BreakKey, bool bLast = false)
+        {
+            DataGridView dgv = dgvAverage;
+            try
+            {
+                // 先頭は抜ける
+                if (!bLast && nIndex < 1) return;
+
+                // ----- 発注者平均値
+                int DivisionKey = BreakKey[(int)SumArea.Division];
+                int OrderKey = BreakKey[(int)SumArea.Order];
+                DataGridViewRow OrderRow = dgv.Rows
+                                            .Cast<DataGridViewRow>()
+                                            .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.DivisionCode].Value) == DivisionKey
+                                                        && CommonMotions.cnvInt(x.Cells[(int)DispGrid.OrderCode].Value) == OrderKey)
+                                            .First();
+                if (OrderRow == null) return;
+
+                // 発注者平均値セット
+                double dAvgOrder = dgv.Rows
+                                .Cast<DataGridViewRow>()
+                                .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.DivisionCode].Value) == DivisionKey
+                                            && CommonMotions.cnvInt(x.Cells[(int)DispGrid.OrderCode].Value) == OrderKey)
+                                .Average(y => CommonMotions.cnvDouble(y.Cells[(int)DispGrid.ConstScore].Value));
+
+                // 発注者平均値セット
+                OrderRow.Cells[(int)DispGrid.OrderAvgScore].Value = dAvgOrder.ToString("0.0");
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                if (nIndex >= 0)
+                {
+                    // 名前のセット
+                    DataGridViewRow CurRow = dgv.Rows[nIndex];
+                    CurRow.Cells[(int)DispGrid.OrderName].Value = GetName[(int)SumArea.Order];
+                }
+            }
+        }
+        #endregion
+
+        #region 発注者別コントロールブレイク担当者平均点表示
+        /// <summary>
+        /// 発注者別コントロールブレイク担当者平均点表示
+        /// </summary>
+        private void CtrlBrkProcType1Person(int nIndex, string[] GetName, ref int[] GetCode, ref int[] BreakKey, bool bLast = false)
+        {
+            DataGridView dgv = dgvAverage;
+            try
+            {
+                // 先頭は抜ける
+                if (!bLast && nIndex < 1) return;
+
+                // ----- 担当者平均値
+                int DivisionKey = BreakKey[(int)SumArea.Division];
+                int OrderKey = BreakKey[(int)SumArea.Order];
+                int PersonKey = BreakKey[(int)SumArea.Person];
+                DataGridViewRow PersonRow = dgv.Rows
+                                            .Cast<DataGridViewRow>()
+                                            .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.DivisionCode].Value) == DivisionKey
+                                                        && CommonMotions.cnvInt(x.Cells[(int)DispGrid.OrderCode].Value) == OrderKey
+                                                        && CommonMotions.cnvInt(x.Cells[(int)DispGrid.ManCode].Value) == PersonKey)
+                                            .First();
+                if (PersonRow == null) return;
+
+                // 担当者者平均値セット
+                double dAvgPerson = dgv.Rows
+                                .Cast<DataGridViewRow>()
+                                .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.DivisionCode].Value) == DivisionKey
+                                            && CommonMotions.cnvInt(x.Cells[(int)DispGrid.OrderCode].Value) == OrderKey
+                                            && CommonMotions.cnvInt(x.Cells[(int)DispGrid.ManCode].Value) == PersonKey)
+                                .Average(y => CommonMotions.cnvDouble(y.Cells[(int)DispGrid.ConstScore].Value));
+
+                // 発注者平均値セット
+                PersonRow.Cells[(int)DispGrid.ManAvgScore1].Value = dAvgPerson.ToString("0.0");
+                PersonRow.Cells[(int)DispGrid.ManAvgScore2].Value = dAvgPerson.ToString("0.0");
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                if (nIndex >= 0)
+                {
+                    // 名前のセット
+                    DataGridViewRow CurRow = dgv.Rows[nIndex];
+                    CurRow.Cells[(int)DispGrid.ManName1].Value = GetName[(int)SumArea.Person];
+                    CurRow.Cells[(int)DispGrid.ManName2].Value = GetName[(int)SumArea.Person];
+                }
+            }
+        }
+        #endregion
+
+        #region 担当者者別コントロールブレイク
+        /// <summary>
+        /// 担当者者別コントロールブレイク
+        /// </summary>
+        private void CtrlBrkProcType2(int nIndex, string[] GetName, ref int[] GetCode, ref int[] BreakKey)
+        {
+            try
+            {
+                bool[] bExecute = new bool[] { false, false, false };
+                // ブレイク条件の上から比較する
+                if (GetCode[(int)SumArea.Person] != BreakKey[(int)SumArea.Person])
+                {
+                    bExecute[0] = true;
+                    bExecute[1] = true;
+                    bExecute[2] = true;
+                }
+                else if (GetCode[(int)SumArea.Division] != BreakKey[(int)SumArea.Division])
+                {
+                    bExecute[0] = true;
+                    bExecute[1] = true;
+                }
+                else if (GetCode[(int)SumArea.Order] != BreakKey[(int)SumArea.Order])
+                {
+                    bExecute[0] = true;
+                }
+
+                // 発注者平均区分表示
+                if (bExecute[0]) CtrlBrkProcType2Division(nIndex, GetName, ref GetCode, ref BreakKey);
+
+                // 発注者平均区分表示
+                if (bExecute[1]) CtrlBrkProcType2Order(nIndex, GetName, ref GetCode, ref BreakKey);
+
+                // 担当者平均点表示
+                if (bExecute[2]) CtrlBrkProcType2Person(nIndex, GetName, ref GetCode, ref BreakKey);
+
+                // ----- 新キーセット
+                if (bExecute[0]) BreakKey[(int)SumArea.Division] = GetCode[(int)SumArea.Division];
+
+                if (bExecute[1]) BreakKey[(int)SumArea.Order] = GetCode[(int)SumArea.Order];
+
+                if (bExecute[2]) BreakKey[(int)SumArea.Person] = GetCode[(int)SumArea.Person];
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 担当者者別コントロールブレイク担当者平均点表示
+        /// <summary>
+        /// 担当者者別コントロールブレイク担当者平均点表示
+        /// </summary>
+        private void CtrlBrkProcType2Person(int nIndex, string[] GetName, ref int[] GetCode, ref int[] BreakKey, bool bLast = false)
+        {
+            DataGridView dgv = dgvAverage;
+            try
+            {
+                // 先頭は抜ける
+                if (!bLast && nIndex < 1) return;
+
+                // ----- 担当者平均値
+                int PersonKey = BreakKey[(int)SumArea.Person];
+                DataGridViewRow PersonRow = dgv.Rows
+                                            .Cast<DataGridViewRow>()
+                                            .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.ManCode].Value) == PersonKey)
+                                            .First();
+                if (PersonRow == null) return;
+
+                // 担当者者平均値セット
+                double dAvgPerson = dgv.Rows
+                                .Cast<DataGridViewRow>()
+                                .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.ManCode].Value) == PersonKey)
+                                .Average(y => CommonMotions.cnvDouble(y.Cells[(int)DispGrid.ConstScore].Value));
+
+                // 発注者平均値セット
+                PersonRow.Cells[(int)DispGrid.ManAvgScore1].Value = dAvgPerson.ToString("0.0");
+                PersonRow.Cells[(int)DispGrid.ManAvgScore2].Value = dAvgPerson.ToString("0.0");
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                if (nIndex >= 0)
+                {
+                    // 名前のセット
+                    DataGridViewRow CurRow = dgv.Rows[nIndex];
+                    CurRow.Cells[(int)DispGrid.ManName1].Value = GetName[(int)SumArea.Person];
+                    CurRow.Cells[(int)DispGrid.ManName2].Value = GetName[(int)SumArea.Person];
+                }
+            }
+        }
+        #endregion
+
+        #region 発注区分別コントロールブレイク発注区分平均点表示
+        /// <summary>
+        /// 発注区分別コントロールブレイク発注者平均区分表示
+        /// </summary>
+        private void CtrlBrkProcType2Division(int nIndex, string[] GetName, ref int[] GetCode, ref int[] BreakKey, bool bLast = false)
+        {
+            DataGridView dgv = dgvAverage;
+            try
+            {
+                // 先頭は抜ける
+                if (!bLast && nIndex < 1) return;
+
+                // ----- 発注区分平均値
+                int PersonKey = BreakKey[(int)SumArea.Person];
+                int DivisionKey = BreakKey[(int)SumArea.Division];
+                DataGridViewRow DiviRow = dgv.Rows
+                                            .Cast<DataGridViewRow>()
+                                            .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.ManCode].Value) == PersonKey
+                                                        && CommonMotions.cnvInt(x.Cells[(int)DispGrid.DivisionCode].Value) == DivisionKey)
+                                            .First();
+                if (DiviRow == null) return;
+
+                // 発注区分平均値セット
+                double dAvgDivi = dgv.Rows
+                                .Cast<DataGridViewRow>()
+                                .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.ManCode].Value) == PersonKey
+                                            && CommonMotions.cnvInt(x.Cells[(int)DispGrid.DivisionCode].Value) == DivisionKey)
+                                .Average(y => CommonMotions.cnvDouble(y.Cells[(int)DispGrid.ConstScore].Value));
+
+                // 発注区分平均値セット
+                DiviRow.Cells[(int)DispGrid.DiviAvgScore].Value = dAvgDivi.ToString("0.0");
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                if (nIndex >= 0)
+                {
+
+                    // 名前のセット
+                    DataGridViewRow CurRow = dgv.Rows[nIndex];
+                    CurRow.Cells[(int)DispGrid.DiviName].Value = GetName[(int)SumArea.Division];
+                }
+            }
+        }
+        #endregion
+
+        #region 担当者者別コントロールブレイク発注者平均点表示
+        /// <summary>
+        /// 担当者者別コントロールブレイク発注者平均点表示
+        /// </summary>
+        private void CtrlBrkProcType2Order(int nIndex, string[] GetName, ref int[] GetCode, ref int[] BreakKey, bool bLast = false)
+        {
+            DataGridView dgv = dgvAverage;
+            try
+            {
+                // 先頭は抜ける
+                if (!bLast && nIndex < 1) return;
+
+                // ----- 発注者平均値
+                int PersonKey = BreakKey[(int)SumArea.Person];
+                int DivisionKey = BreakKey[(int)SumArea.Division];
+                int OrderKey = BreakKey[(int)SumArea.Order];
+                DataGridViewRow OrderRow = dgv.Rows
+                                            .Cast<DataGridViewRow>()
+                                            .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.ManCode].Value) == PersonKey
+                                                        && CommonMotions.cnvInt(x.Cells[(int)DispGrid.DivisionCode].Value) == DivisionKey
+                                                        && CommonMotions.cnvInt(x.Cells[(int)DispGrid.OrderCode].Value) == OrderKey)
+                                            .First();
+                if (OrderRow == null) return;
+
+                // 発注者平均値セット
+                double dAvgOrder = dgv.Rows
+                                .Cast<DataGridViewRow>()
+                                .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispGrid.ManCode].Value) == PersonKey
+                                            && CommonMotions.cnvInt(x.Cells[(int)DispGrid.DivisionCode].Value) == DivisionKey
+                                            && CommonMotions.cnvInt(x.Cells[(int)DispGrid.OrderCode].Value) == OrderKey)
+                                .Average(y => CommonMotions.cnvDouble(y.Cells[(int)DispGrid.ConstScore].Value));
+
+                // 発注者平均値セット
+                OrderRow.Cells[(int)DispGrid.OrderAvgScore].Value = dAvgOrder.ToString("0.0");
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                if (nIndex >= 0)
+                {
+                    // 名前のセット
+                    DataGridViewRow CurRow = dgv.Rows[nIndex];
+                    CurRow.Cells[(int)DispGrid.OrderName].Value = GetName[(int)SumArea.Order];
+                }
+            }
+        }
+        #endregion
+    }
+}
